(function($) {
  $('.l-content').each(function() {
    var container = this;

    // Activate on textfield input
    $('.l-region--content #block-wcm-panels-settings-wcm-accordion-filter .form-text, .l-region--content .pane-wcm-panels-settings-wcm-accordion-filter .form-text', container).on('keyup input', function() {
      // Get search string
      var searchValue = $(this).val().trim().toLowerCase();

      // Get accordion groups
      var accordionGroups = $('.accordion', container);

      // If the first accordion group is preceded by an h2, that h2 is where filtering begins
      if (accordionGroups.first().prev('h2').length > 0) {
        start = accordionGroups.first().prev('h2');
      }
      // Else the first accordion itself is where filtering begins
      else {
        start = accordionGroups.first();
      }

      // If a search value has been entered
      if (searchValue.length > 0) {

        // Hide all content before the filter starting point
        start.prevAll().hide();

        // Loop through all accordion groups
        accordionGroups.each(function() {
          var group = $(this);

          // Loop through each accordion in the group
          group.find('.accordion-item').each(function() {
            var accordion = $(this);
            var header = accordion.find('.accordion-header').text().toLowerCase();
            var content = accordion.find('.accordion-panel').text().toLowerCase();

            // Hide or show accordion, depending on whether it contains searched value
            if (header.indexOf(searchValue) + content.indexOf(searchValue) < -1) {
              accordion.hide();
            }
            else {
              accordion.show();
              accordion.parents('.pane-views-panes').show();
            }
          });

          // If no acccordions in the group are visible, hide the entire group
          if (group.find('.accordion-item').filter(':visible').length == 0) {
            group.prevUntil('.accordion').hide();
            group.parents('.pane-views-panes').hide();
            group.prev('h2').hide();
          }
          // Else if there are any visible accordions in the group, show its h2, if it has one
          else if (group.prev('h2').length > 0) {
            group.parents('.pane-views-panes').show();
            group.prev('h2').show();
          }
        });
      }
      // If no search value has been entered, reset all hidden content
      else {
        accordionGroups.show();
        accordionGroups.find('.accordion-item').show();
        accordionGroups.prevUntil('.accordion').show();
        accordionGroups.parents('.pane-views-panes').show();
      }

      // Show or hide the 'No Results' message, depending on whether any accordions are visible.
      var noResults = $('.accordions-no-results', container);
      if (accordionGroups.find('.accordion-item').filter(':visible').length > 0) {
        noResults.hide();
      } else {
        noResults.show();
      }
    });
  });
})(jQuery);
