<?php

/**
 * @file
 * Contains a pre-process hook for 'fieldable_panels_pane'.
 */


/**
 * Create variables for custom panels panes created via FPP
 **
 * Implements hook_preprocess_panels_pane().
 */

function wcm_omega_preprocess_fieldable_panels_pane(&$vars) {
  $type = $vars['elements']['#bundle'];

  // Tile panes
  if (in_array($type, array('tile_pane', 'tile_pane_plus_text_area'))) {

    if (empty($vars['tile_title_heading'])) {
      $vars['tile_title_heading'] = 'h2';
    }

    $vars['tile_title'] = NULL;
    if (!empty($vars['content']['title'])) {
      $vars['tile_title'] = $vars['content']['title']['#value'];
    }
    $vars['tile_url'] = NULL;
    if (!empty($vars['content']['field_tile_link'])) {
      $link = $vars['content']['field_tile_link']['#items'][0];
      $options = array('absolute' => TRUE);
      if (!empty($link['fragment'])) {
        $options['fragment'] = $link['fragment'];
      }
      if (!empty($link['query'])) {
        $options['query'] = $link['query'];
      }
      $vars['tile_url'] = url($link['url'], $options);
    }
    if (!empty($vars['content']['field_background_color'])) {
      $vars['classes_array'][] = $vars['content']['field_background_color']['#items'][0]['value'];
    }
    if (!empty($vars['content']['field_background_color_2'])) {
      $vars['classes_array'][] = $vars['content']['field_background_color_2']['#items'][0]['value'];
    }
    $vars['tile_icon'] = NULL;
    if (!empty($vars['content']['field_tile_image_style'])) {
      $style = $vars['content']['field_tile_image_style']['#items'][0]['value'];
      $vars['tile_icon'] = ($style == 'icon');

      if (!empty($style)) {
        $vars['classes_array'][] = 'tile-image-style-' . $style;
      }
    }
    if (!empty($vars['tile_url'])) {
      $vars['classes_array'][] = 'tile-pane-linked';
    }
  }

  // Image panes
  elseif ($type == 'image') {
    if (!empty($vars['content']['field_basic_image_image']) && !empty($vars['elements']['#fieldable_panels_pane']->field_ocio_link)) {
      $vars['content']['field_basic_image_image'][0]['#path'] = array('path' => $vars['elements']['#fieldable_panels_pane']->field_ocio_link['und'][0]['display_url']);
    }
  }
}
